#include <sys/select.h>

/*

** Copyright (C) 1994,1991,2008
** Shinji Kono (kono@ie.u-ryukyu.ac.jp)
**   University of the Ryukyus
**
**    Everyone is permitted to do anything on this program
**    including copying, modifying, improving,
**    as long as you don't try to pretend that you wrote it.
**    i.e., the above copyright notice has to appear in all copies.
**    Binary distribution requires original version messages.
**    You don't have to ask before copying, redistribution or publishing.
**    THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE.

This example is designed to demostrate how busy wait eats CPU
resource. You should not use this library without careful consideration.

 */

int
kbhit(int fd)
{
    int c;
    fd_set readers,readfds;
    struct timeval timeout;
    timeout.tv_sec = 0; 
    timeout.tv_usec = 0;

    FD_SET(fd,&readers);
    readfds = readers;
    c = select(1,&readfds,(fd_set *)0,(fd_set *)0,
					    &timeout);
    if (c<=0) return 0;
    if (! FD_ISSET(0,&readers)) return 0;
    return 1;
}

/* end */
